package com.agentfactory.agentspeak.debugger;

import java.util.LinkedList;
import java.util.List;

import com.agentfactory.agentspeak.interpreter.Utilities;
import com.agentfactory.agentspeak.interpreter.mentalstate.Commitment;
import com.agentfactory.agentspeak.interpreter.mentalstate.IPlanStep;
import com.agentfactory.logic.update.reasoner.Bindings;

public class CommitmentDescription {
	public String event;
	public String current;
	public List<String> stack;
	public Bindings bindings;
	
	public CommitmentDescription(Commitment commitment) {
		event = commitment.getEvent().toString();
		if (commitment.getCurrent() != null) {
			current = commitment.getCurrent().toString();
		}
		stack = new LinkedList<String>();
		for (IPlanStep step: commitment.getStack()) {
			stack.add(step.toString());
		}
		bindings = commitment.bindings().merge(new Bindings());
	}
	
	@Override
	public String toString() {
		String output = event + "<- " + Utilities.presenter.toString(bindings);
		for (String step: stack) {
			output+=",\n\t" + step;
		}
		return output + ";";
	}
}
