package com.agentfactory.agentspeak.interpreter.control;

import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import com.agentfactory.agentspeak.interpreter.Utilities;
import com.agentfactory.agentspeak.interpreter.mentalstate.ASEvent;
import com.agentfactory.agentspeak.interpreter.mentalstate.PlanRule;
import com.agentfactory.logic.update.reasoner.Bindings;

public class BasicOptionGenerator implements IOptionGenerator {
	protected Map<String, List<PlanRule>> ruleEventMap;
	
	public BasicOptionGenerator(Map<String, List<PlanRule>> ruleEventMap) {
		this.ruleEventMap = ruleEventMap;
	}
	
	@Override
	public List<PlanRule> generate(ASEvent event) {
		List<PlanRule> list = ruleEventMap.get(Utilities.createSignature(event.content()));
		
		List<PlanRule> options = new LinkedList<PlanRule>();
		for (PlanRule rule: list) {
			if (rule.getTriggeringEvent().matches(event)) {
				Bindings set = rule.getTriggeringEvent().unifyWith(event);
				if (set != null) {
					options.add(rule.apply(set));
				}
			}
		}
		return options;
	}

}
