package com.agentfactory.logic.update.interpreter;

import com.agentfactory.logic.update.lang.Predicate;

public abstract class AbstractComponent {
	protected AbstractLanguageAgent agent;
	private Predicate id;
	
	public void setId(Predicate id) {
		this.id = id;
	}
	
	public Predicate getId() {
		return id;
	}
	
	public void setAgent(AbstractLanguageAgent agent) {
		this.agent = agent;
	}
	
	protected void addBelief(String belief) {
		agent.addBelief((Predicate) CoreUtilities.factory.createFormula(belief));
	}
	
	protected void removeBelief(String belief) {
		agent.removeBelief((Predicate) CoreUtilities.factory.createFormula(belief));
	}
	
	public String toString() {
		return id.toString() + "->" + getClass().getName();
	}
}