package com.agentfactory.platform.core;

/**
 * This class contains both the envelope and payload to be sent using a
 * FIPA Message Transport Service.
 *
 * @author  Rem Collier
 */
public class TransportMessage {
    private IEnvelope envelope;
    private byte[] payload;
    
    public TransportMessage(IEnvelope envelope, IMessage message) {
        this.envelope = envelope;
        this.payload = message.toByteArray();
    }
    
    public IEnvelope getEnvelope() {
        return envelope;
    }
    
    public byte[] getPayload() {
        return payload;
    }
}
