package com.agentfactory.smt;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;
import java.net.UnknownHostException;
import java.util.HashMap;
import java.util.Map;

import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;

public class CommandGUI extends JFrame {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private Map<String, CommandClient> clients;
	JTextArea output;
	JTextField input;
	JList platforms;
	JButton sendButton;
	
	public CommandGUI() {
		clients = new HashMap<String, CommandClient>();
		
		this.setLayout(new BorderLayout());
		output = new JTextArea();
		this.add(output, BorderLayout.CENTER);
		JPanel panel = new JPanel(new BorderLayout());
		platforms = new JList(new DefaultListModel());
		panel.add(new JScrollPane(platforms), BorderLayout.CENTER);
		panel.add(new JLabel("Platforms:"), BorderLayout.NORTH);
		this.add(panel, BorderLayout.WEST);
		input = new JTextField();
		panel = new JPanel(new BorderLayout());
		panel.add(input, BorderLayout.CENTER);
		sendButton = new JButton("Send");
		getRootPane().setDefaultButton(sendButton);
		sendButton.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				String[] command = input.getText().split(" ");
				if (command[0].equals("CONNECT")) {
					CommandClient client = new CommandClient(command[1], Integer.parseInt(command[2]));
					try {
						client.connect();
						clients.put(client.id(), client);
						output.append("CONNECTED TO: " + command[1] + ":" + command[2] + " -> " + client.id() + "\n");
					} catch (UnknownHostException e) {
						output.append("UNKNOWN CLIENT: " + input.getText() + "\n");
					}
				} else {
					CommandClient client = clients.get(command[0]);
					if (client == null) {
						output.append("UNKNOWN CLIENT: " + input.getText() + "\n");
					} else {
						try {
							output.append(client.send(input.getText().substring(command[0].length() + 1)));
						} catch (IOException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
					}
				}
				
				
			}
			
		});
		panel.add(sendButton, BorderLayout.EAST);
		this.add(panel, BorderLayout.SOUTH);
		
		setTitle("AF Command GUI");
		pack();
		setSize(250, 400);
	}
	
	public static void main(String[] args) {
		new CommandGUI().setVisible(true);
	}
}
