/*
 * AUMLView.java
 *
 * Created on January 16, 2009, 12:54 PM
 */

package com.agentfactory.visualiser;

import com.agentfactory.platform.core.IMessage;
import com.agentfactory.visualiser.impl.MessageStore;
import java.util.Observable;
import java.util.Observer;
import javax.swing.DefaultListModel;

/**
 *
 * @author  remcollier
 */
public class AUMLView extends javax.swing.JInternalFrame implements Observer {
    private MessageStore store;
    
    /** Creates new form AUMLView */
    public AUMLView(MessageStore store) {
        this.store = store;
        initComponents();
        updateView();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jSplitPane1 = new javax.swing.JSplitPane();
        jScrollPane1 = new javax.swing.JScrollPane();
        messageList = new javax.swing.JList();
        jPanel1 = new javax.swing.JPanel();

        setIconifiable(true);
        setMaximizable(true);
        setResizable(true);
        setTitle("AUML Message View");

        jSplitPane1.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);

        messageList.setModel(new DefaultListModel());
        jScrollPane1.setViewportView(messageList);

        jSplitPane1.setLeftComponent(jScrollPane1);
        jSplitPane1.setRightComponent(jPanel1);

        getContentPane().add(jSplitPane1, java.awt.BorderLayout.CENTER);

        pack();
    }// </editor-fold>//GEN-END:initComponents


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JList messageList;
    // End of variables declaration//GEN-END:variables

    public void update(Observable o, Object arg) {
        System.out.println("Observing: " + o);
        System.out.println("Event: " + arg);
        if (arg.equals("new-messages")) {
            updateView();
        }
    }
    
    private void updateView() {
        DefaultListModel model = (DefaultListModel) messageList.getModel();
        model.clear();
        for (IMessage message: store.getMessages()) {
            model.addElement(message);
        }
    }

}
